/*
   main.c: place holder of GNU LIBICONV for only Shift_JIS.

   Copyright (C) 1999-2001 Free Software Foundation, Inc.
   Copyright (C) 1998-2003 Static (http://member.nifty.ne.jp/Static/).

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this program; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Author: .exe (Static) <gStatic@infoseek.jp>
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

typedef void* iconv_t;

iconv_t libiconv_open (const char* tocode, const char* fromcode);
size_t libiconv (iconv_t cd, const char* * inbuf, size_t *inbytesleft, char* * outbuf, size_t *outbytesleft);
int libiconv_close (iconv_t cd);

#define CP_932 932


BOOL WINAPI DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			break;
		case DLL_PROCESS_DETACH:
			break;
		default:
			break;
	}


	return TRUE;
}


iconv_t libiconv_open (const char* tocode, const char* fromcode)
{
//	OutputDebugString("libiconv_open Ăяo");

	if (lstrcmpi(fromcode, "UTF-8") == 0) {
		if (lstrcmpi(tocode, "Shift_JIS") == 0) {
			return (iconv_t)MAKELONG(CP_UTF8, CP_932);
		}
	} else if (lstrcmpi(fromcode, "Shift_JIS") == 0) {
		if (lstrcmpi(tocode, "UTF-8") == 0) {
			return (iconv_t)MAKELONG(CP_932,  CP_UTF8);
		}
	}

	return (iconv_t)-1;
}

size_t libiconv (iconv_t cd, const char* * inbuf, size_t *inbytesleft, char* * outbuf, size_t *outbytesleft)
{
	char* buffer;
	UINT size;

//	OutputDebugString("libiconv Ăяo");

	switch ((DWORD)cd)
	{
	case MAKELONG(CP_UTF8, CP_932):  // UTF-8     -> Shift_JIS
	case MAKELONG(CP_932,  CP_UTF8): // Shift_JIS -> UTF-8
		size = (*inbytesleft) * 2;
		buffer = (char *)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size);
			size = MultiByteToWideChar(LOWORD((DWORD)cd), 0, *inbuf, *inbytesleft, (USHORT *)buffer, size);
			size = WideCharToMultiByte(HIWORD((DWORD)cd), 0, (USHORT *)buffer, size, *outbuf, *outbytesleft, NULL, NULL);
		HeapFree(GetProcessHeap(), 0, buffer);

		if (size == 0) {
			*inbuf += *outbytesleft;
			*inbytesleft -= *outbytesleft;
			*outbuf += *outbytesleft;
			*outbytesleft = 0;

			return (size_t)-1;
		} else {
			*inbuf += *inbytesleft;
			*inbytesleft = 0;
			*outbuf += size;
			*outbytesleft -= size;
		}

		break;
	default:
		return (size_t)-1;

		break;
	}


	return (size_t)0;
}

int libiconv_close (iconv_t cd)
{
//	OutputDebugString("libiconv_close Ăяo");


	return (int)0;
}
